---
title: CSSStyleDeclaration.setProperty()
slug: Web/API/CSSStyleDeclaration/setProperty
tags:
  - API
  - CSSOM
  - Method
  - Reference
---
<p>{{ APIRef("CSSOM") }}</p>

<p><span class="seoSummary">The <strong><code>CSSStyleDeclaration.setProperty()</code></strong> method interface sets a new value for a property on a CSS style declaration object.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>style</em>.setProperty(<em>propertyName</em>, <em>value, priority</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><em><code>propertyName</code></em> is a {{domxref('DOMString')}} representing the CSS property name (hyphen case) to be modified.</li>
 <li><em><code>value</code></em> {{optional_inline}} is a {{domxref('DOMString')}} containing the new property value. If not specified, treated as the empty string.
  <ul>
   <li>Note: <em><code>value</code></em> must not contain <code>"!important"</code> -- that should be set using the <em><code>priority</code></em> parameter.</li>
  </ul>
 </li>
 <li><em><code>priority</code></em> {{optional_inline}} is a {{domxref('DOMString')}} allowing the "important" CSS priority to be set. If not specified, treated as the empty string. The following values are accepted:
  <ul>
   <li>String value <code>"important"</code></li>
   <li>Keyword <code>undefined</code></li>
   <li>String empty value <code>""</code></li>
  </ul>
 </li>
</ul>

<h3 id="Return_value">Return value</h3>

<ul>
 <li>{{jsxref('undefined')}}</li>
</ul>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>{{domxref('DOMException')}} (NoModificationAllowedError): if the property or declaration block is read only.</li>
</ul>

<p>If <em><code>priority</code></em> can be omitted, JavaScript has a special simpler syntax for setting a CSS property on a style declaration object:</p>

<pre class="syntaxbox notranslate"><em>style</em>.cssPropertyName = 'value';</pre>

<h2 id="Examples">Examples</h2>

<p>In this example we have three buttons, which can be pressed to dynamically alter our box paragraph's border, background color, and text color to random values (see the live example at the end of this section).</p>

<p>We know that the rule we want to alter to do this is contained inside the second stylesheet applied to the page, so we grab a reference to it using <code><a href="/en-US/docs/Web/API/Document/styleSheetSets">document.styleSheets[1]</a></code>. We then loop through the different rules contained inside the stylesheet, which are contained in the array found at <code><a href="/en-US/docs/Web/API/CSSStyleSheet/cssRules">stylesheet.cssRules</a></code>; for each one, we check whether its <code><a href="/en-US/docs/Web/API/CSSStyleRule/selectorText">CSSStyleRule.selectorText</a></code> property is equal to the selector <code>.box p</code>, which indicates it is the one we want.</p>

<p>If so, we store a reference to this <code>CSSStyleRule</code> object in a variable. We then use three functions to generate random values for the properties in question, and update the rule with these values. In each case, this is done with the <code>setProperty()</code> method, for example <code>boxParaRule.style.setProperty('border', newBorder);</code></p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div class="controls"&gt;
  &lt;button class="border"&gt;Border&lt;/button&gt;
  &lt;button class="bgcolor"&gt;Background&lt;/button&gt;
  &lt;button class="color"&gt;Text&lt;/button&gt;
&lt;/div&gt;
&lt;div class="box"&gt;
  &lt;p&gt;Box&lt;/p&gt;
&lt;/div&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">html {
  background: orange;
  font-family: sans-serif;
  height: 100%;
}

body {
  height: inherit;
  width: 80%;
  min-width: 500px;
  max-width: 1000px;
  margin: 0 auto;
}

.controls {
  display: flex;
  justify-content: space-around;
  align-items: center;
}

div button {
  flex: 1;
  margin: 20px;
  height: 30px;
  line-height: 30px;
}

.box {
  display: flex;
  justify-content: center;
  align-items: center;
  height: calc(100% - 70px);
}

.box p {
  width: 50%;
  text-align: center;
  font-weight: bold;
  font-size: 40px;
  height: 150px;
  line-height: 150px;
  background: red;
  border: 5px solid purple;
  color: white;
  transition: all 1s;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">const borderBtn = document.querySelector('.border');
const bgColorBtn = document.querySelector('.bgcolor');
const colorBtn = document.querySelector('.color');
const box = document.querySelector('.box');

function random(min,max) {
  const num = Math.floor(Math.random()*(max-min)) + min;
  return num;
}

function randomColor() {
  return 'rgb(' + random(0,255) + ', ' + random(0,255) + ', ' + random(0,255) +  ')';
}

const stylesheet = document.styleSheets[1];
let boxParaRule;

for(let i = 0; i &lt; stylesheet.cssRules.length; i++) {
  if(stylesheet.cssRules[i].selectorText === '.box p') {
    boxParaRule = stylesheet.cssRules[i];
  }
}

function setRandomBorder() {
  const newBorder = random(1, 50) + 'px solid ' + randomColor();
  boxParaRule.style.setProperty('border', newBorder);
}

function setRandomBgColor() {
  const newBgColor = randomColor();
  boxParaRule.style.setProperty('background-color', newBgColor);
}

function setRandomColor() {
  const newColor = randomColor();
  boxParaRule.style.setProperty('color', newColor);
}

borderBtn.addEventListener('click', setRandomBorder);
bgColorBtn.addEventListener('click', setRandomBgColor);
colorBtn.addEventListener('click', setRandomColor);</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Examples', '100%', 400)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSSOM', '#dom-cssstyledeclaration-setproperty', 'CSSStyleDeclaration.setProperty()')}}</td>
   <td>{{Spec2('CSSOM')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Style', 'css.html#CSS-CSSStyleDeclaration', 'CSSStyleDeclaration')}}</td>
   <td>{{Spec2('DOM2 Style')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSSStyleDeclaration.setProperty")}}</p>
